<template>
  <div class="form">
    <div class="form-inputs">
      <div v-for="n in length" :key="n - 1" class="form-group">
        <BaseInput
          v-model="form[n - 1]"
          type="number"
          :maxlength="1"
          :disabled="!isFieldEnabled(n - 1)"
          :is-valid="!!form[n - 1]"
          :index="n - 1"
          ref="input"
          @paste.prevent
          @drop.prevent
          @input="v => onInput(v, n - 1)"
        />
      </div>
    </div>
    <div v-if="isValid" class="form__action">
      <BaseButton :is-loading="isLoading" @click="onSubmit">Submit</BaseButton>
    </div>
  </div>
</template>

<script>
import BaseButton from '../base/BaseButton'
import BaseInput from "../base/BaseInput"
import { isNumber } from '../../utils/helpers'

export default {
  components: { BaseInput, BaseButton },
  props: {
    isLoading: {
      type: Boolean,
      default: false
    },
    length: {
      type: Number,
      default: 5
    }
  },
  data() {
    const form = Array(this.length).fill('')
    return {
      form
    }
  },
  computed: {
    isValid () {
      return this.form.every(number => number && isNumber(number))
    }
  },
  methods: {
    isFieldEnabled(n) {
      if (n === 0) {
        return true
      }
      return this.form.every((value, index) => {
        if (index < n) {
          return !!value
        }
        return true
      })
    },
    onInput (value, n) {
      if (value && this.form[n] && n !== this.length - 1) {
        this.focusNext(n + 1)
      }
    },
    focusNext (n) {
      const inputRefEl = this.$refs.input.find(input => {
        return input.$attrs.index === n
      })
      if (inputRefEl) {
        this.$nextTick(() => {
          inputRefEl.focus()
        })
      }
    },
    onSubmit () {
      if (!this.isValid) {
        return
      }
      this.$emit('submit', this.form.join(''))
    }
  }
}
</script>

<style scoped lang="scss">
.form {
  &-inputs {
    display: flex;
  }
  &-group {
    &:not(:last-child) {
      margin-right: 10px;
    }
  }
  &__action {
    margin-top: 20px;
    text-align: right;
  }
}
</style>